<?php
/**
 * @name sw_crontrol.php
 * @description Page de contrôle du plugin de Switch
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 18/04/2013
 */
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once $path.'/Model_adm.php';
include_once 'model_gesa.php';
$temps = microtime();
$temps = explode(' ', $temps);
$debut = $temps[1] + $temps[0];
//chemin d'accès au repertoire du plugin contenant les templates
$arr = Model_esia::getWebPlugin($dbconnection,false,'GESA');
$template_path= $path.$arr[0]['apache_path'].'template/';

//test des droits d'accès
if($user->getAccess($dbconnection,"esia_device") ==1)
{
	$action = $_GET['action'];
	$err=0;
	$gesa_id=$_GET['id'];
	if(!isset($_GET['id']))
	{
		//si se n'est pas une modification/ajout  ou supression on redirige vers la gestion des noeuds
		header('Location: /administration.php?admin=device');
		exit();
	}
	if($action=='add' || $action=='update')
	{
		try
		{
			$gesa = Model_esia::InstanceNode($dbconnection,$gesa_id);
			if($gesa->getType()=="gesa")
			{
				$link = $gesa->getName();
				if(gethostbyname($gesa->getName())==$gesa->getName())
				{
					$link = $gesa->getIPAddress();
				}
				exec(NRPE_PATH.' -H '.$link.' -p 5666 -c gesa_version',$output);
				//echo NRPE_PATH.' -H '.$gesa->getName().' -p 5666 -c gesa_version <br />';
				//print_r($output);
				$sn = preg_split("#:#", $output[0]);
				$sn = trim($sn[1]);
				$kernel = preg_split("#:#", $output[2]);
				$kernel= $kernel[1];
				//echo $sn;
				if(!empty($sn))
				{
					$dom = new DOMDocument();
					//echo 'http://'.GESA_SRV.'/info.php?SN='.$sn.'&type=xml';
					$dom->load('http://'.GESA_SRV.'/info.php?SN='.$sn.'&type=xml');
					//print_r($dom->getElementsByTagName('state'));
					$state  = $dom->getElementsByTagName('state')->item(0)->nodeValue;
					//print_r($state);
					//echo "state: $state";
					if($state == 200)
					{
						$model = $dom->getElementsByTagName('model')->item(0)->nodeValue;
						$maxSlot = $dom->getElementsByTagName('maxSlot')->item(0)->nodeValue;
						$client = $dom->getElementsByTagName('client')->item(0)->nodeValue;
						$softwareVersion = $dom->getElementsByTagName('softwareVersion')->item(0)->nodeValue;
						$server = $dom->getElementsByTagName('server')->item(0)->nodeValue;
						$activateDate = $dom->getElementsByTagName('activateDate')->item(0)->nodeValue;
						$smarty->assign('gesa_sn',$sn );
						$smarty->assign('gesa_model',$model );
						$smarty->assign('gesa_softwareVersion',$softwareVersion);
						$smarty->assign('gesa_maxSlot',$maxSlot );
						$smarty->assign('gesa_client',$client);
						$smarty->assign('gesa_server',$server);
						$smarty->assign('gesa_activateDate',$activateDate);
						$smarty->assign('gesa_kernel',$kernel);
						if($action=='add')
						{
							Model_gesa::addGESA($dbconnection,$gesa->getId(),$maxSlot,$sn);
						}
						$act = new DOMDocument();
						@$act->load('http://'.GESA_SRV.'/activate.php?SN='.$sn.'&type=xml'.'&server='.gethostname());
						//echo 'http://'.GESA_SRV.'/activate.php?SN='.$sn.'&type=xml'.'&server='.gethostname();
						$actstate  = $act->getElementsByTagName('state')->item(0)->nodeValue;
						//echo "STATE $actstate\n";;
						switch($actstate)
						{
							case 200: 
								//ajout du service GESA_HEALTH
								$check = Model_esia::getPlugin($dbconnection,'GESA_HEALTH');
								$check=$check[0];
								if($action=='add')
								{
									
									if(gethostbyname($gesa->getName())==$gesa->getName())
									{
										$parameter = preg_replace('#\$NRPE_HOST#',$gesa->getIPAddress(),$check['parameter']);
									}
									else
									{	
										$parameter = preg_replace('#\$NRPE_HOST#',$gesa->getName(),$check['parameter']);
									}

									Model_adm::addService($dbconnection,'GESA_HEALTH',$check['id'],$gesa->getId(),300000,$parameter,7,null,null,null,null,null);
								}
								$smarty->assign('gesa_state','OK'); 
								$smarty->assign('gesa_state_msg',$lang['GESA_ADD_SUCCESS']);
								break;
							case 403: 
								$smarty->assign('gesa_state','FAILED');
								$smarty->assign('gesa_state_msg',$lang['GESA_BAD_SERVER']);
								model_adm::deleteNode($dbconnection,$gesa->getId());
								break;
							case 404:
								$smarty->assign('gesa_state','FAILED');
								$smarty->assign('gesa_state_msg','GESA ACTIVATE:'.$lang['GESA_NO_FOUND']);
								model_adm::deleteNode($dbconnection,$gesa->getId());
								break;
							default: 	
								$smarty->assign('gesa_state','FAILED');
								$smarty->assign('gesa_state_msg','GESA ACTIVATE: UNKNOWN ERROR');
						}
					}
					elseif($state == 404)
					{
						Model_gesa::deleteGESA($dbconnection,$gesa->getId());
						$smarty->assign('gesa_state','FAILED');
						$smarty->assign('gesa_state_msg',$lang['GESA_NO_FOUND']);
					}
					else
					{
						$smarty->assign('gesa_state','FAILED');
						$smarty->assign('gesa_state_msg',$lang['GESA_CONNECTION_SERVER_FAILED']);
					}
				}
				else
				{
					$smarty->assign('gesa_state','FAILED');
					$smarty->assign('gesa_state_msg',$lang['GESA_CONNECTION_FAILED']);
				}
			}
		}
		catch(EsiaDbException $e)
		{
			$smarty->assign('gesa_db_error',$e->getMessage());
		}
	}
}
else
{
	$smarty->assign('l_no_access', $lang['NO_ACCESS']);
}
$smarty->assign('l_gesa_sn', $lang['GESA_SN']);
$smarty->assign('l_gesa_slot', $lang['GESA_SLOT_USED']);
$smarty->assign('l_gesa_model', $lang['GESA_MODEL']);
$smarty->assign('l_gesa_client', $lang['GESA_CLIENT']);
$smarty->assign('l_gesa_server', $lang['GESA_SERVER']);
$smarty->assign('l_gesa_kernel', $lang['GESA_KERNEL']);
$smarty->assign('l_gesa_os_version', $lang['GESA_OS_VERSION']);
$smarty->assign('l_gesa_activate_date', $lang['GESA_ACTIVATE_DATE']);
$smarty->display($template_path.'gesa_admin.html');

?>
