<?php
/**
 * @name sw_crontrol.php
 * @description Page de contrôle du plugin de Switch
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 18/04/2013
 */
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';

if(!empty($_GET['gesa']))
{
    $_GET['nodeid']=$_GET['gesa'];
}
$webp_name='GESA';
$webp_model='model_gesa.php'; 
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
 'name'=>$node->getName(),
 'ip'=>$node->getIPAddress(),
 'id'=>$node->getId(),
 'description'=>$node->getDescription(),
 'group'=>$node->getGroup());
 * SMARTY
 $webp_name nom du plugin
 $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
include_once $path.'/inc/common_node_control.php';


if(!isset($_GET['action']))
{
	$_GET['action']='';
}

$gesa = Model_gesa::getInstanceGESA($dbconnection, $node->getId());
$link = $gesa->getName();
if(gethostbyname($gesa->getName())==$gesa->getName())
{
	$link = $gesa->getIPAddress();
}
$descr = htmlentities($gesa->getDescription() , ENT_QUOTES);
//information gesa
$smarty->assign('node_ip',$gesa->getIPAddress() );
$smarty->assign('node_name',$gesa->getName());
$smarty->assign('node_control_id',$gesa->getId());
$smarty->assign('node_description',$descr);
$smarty->assign('node_group',$gesa->getGroup());
$smarty->assign('gesa_name',$gesa->getName() );
$smarty->assign('gesa_id',$gesa->getId() );
$smarty->assign('gesa_local_ip',$gesa->getLocalIPaddress());
$smarty->assign('gesa_public_ip',$gesa->getPublicIPaddress());

if($_GET['action']=='gesainfo')
{
	$smarty->assign('action','gesainfo');
	session_write_close();
	if(!empty($gesa->getSerialNumber()))
	{
		exec(NRPE_PATH.' -H '.$link.' -S '.$gesa->getSerialNumber().' -p 5666 -c gesa_version',$output);
	}
	else
	{
		exec(NRPE_PATH.' -H '.$link.' -p 5666 -c gesa_version',$output);
	}

	$sn = preg_split("#:#", $output[0]);
	$sn = $sn[1];
	$kernel = preg_split("#:#", $output[2]);
	$kernel= $kernel[1];
	$dom = new DOMDocument();
	$dom->load('http://'.GESA_SRV.'/info.php?SN='.$sn.'&type=xml');
	$model = $dom->getElementsByTagName('model')->item(0)->nodeValue;
	$maxSlot = $dom->getElementsByTagName('maxSlot')->item(0)->nodeValue;
	$client = $dom->getElementsByTagName('client')->item(0)->nodeValue;
	$softwareVersion = $dom->getElementsByTagName('softwareVersion')->item(0)->nodeValue;
	$server = $dom->getElementsByTagName('server')->item(0)->nodeValue;
	$activateDate = $dom->getElementsByTagName('activateDate')->item(0)->nodeValue;

	//on récupère la liste des services
	$services = Model_esia::getServices($dbconnection,$gesa->getId());
	foreach($services as $service)
	{
		if($service['name']=='GESA_HEALTH')
		{
			if(preg_match('/CPU#(.*)\nRAM#(.*)\nSDcard#(.*)\nNET#(.*)$/',$service['stdout'],$regs))
			{
				$cpu_img = './img/unknown.png';
				$ram_img = './img/unknown.png';
				$hdd_img = './img/unknown.png';
				$net_img = './img/unknown.png';
				//CPU
				if(preg_match('#OK#',$regs[1]))
				{
					$cpu_img = './img/ok.png';
				}
				elseif(preg_match('#WARNING#',$regs[1]))
				{
		 			$cpu_img = './img/warning.png';
				}
				elseif(preg_match('#CRITICAL#',$regs[1]))
				{
		 			$cpu_img = './img/critical.png';
				}
				//RAM
				if(preg_match('#OK#',$regs[2]))
				{
					$ram_img = './img/ok.png';
				}
				elseif(preg_match('#WARNING#',$regs[2]))
				{
		 			$ram_img = './img/warning.png';
				}
				elseif(preg_match('#CRITICAL#',$regs[2]))
				{
		 			$ram_img = './img/critical.png';
				}
				// SD CARD
				if(preg_match('#OK#',$regs[3]))
				{
					$hdd_img = './img/ok.png';
				}
				elseif(preg_match('#WARNING#',$regs[3]))
				{
		 			$hdd_img = './img/warning.png';
				}
				elseif(preg_match('#CRITICAL#',$regs[3]))
				{
		 			$hdd_img = './img/critical.png';
				}
				//NET
				if(preg_match('#OK#',$regs[4]))
				{
					$net_img = './img/ok.png';
				}
				elseif(preg_match('#WARNING#',$regs[4]))
				{
		 			$net_img = './img/warning.png';
				}
				elseif(preg_match('#CRITICAL#',$regs[4]))
				{
		 			$net_img = './img/critical.png';
				}
				$smarty->assign('cpu_img',$cpu_img);
				$smarty->assign('cpu_msg',$regs[1]);
				$smarty->assign('ram_img',$ram_img);
				$smarty->assign('ram_msg',$regs[2]);
				$smarty->assign('disk_img',$hdd_img);
				$smarty->assign('disk_msg',$regs[3]);
				$smarty->assign('net_img',$net_img);
				$smarty->assign('net_msg',$regs[4]);
			}

		}
	}
	$device = Model_gesa::getNodeLink($dbconnection,$gesa->getId());
	$smarty->assign('gesa_devicelink',count($device));
	$smarty->assign('gesa_slot_used',Model_gesa::count_service_execute($dbconnection,$gesa->getId() ));
	$smarty->assign('gesa_sn',$sn );
	$smarty->assign('gesa_model',$model );
	$smarty->assign('gesa_softwareVersion',$softwareVersion);
	$smarty->assign('gesa_maxSlot',$maxSlot );
	$smarty->assign('gesa_client',$client);
	$smarty->assign('gesa_server',$server);
	$smarty->assign('gesa_activateDate',$activateDate);
	$smarty->assign('gesa_kernel',$kernel);
}
elseif($_GET['action']=='showNode')
{
	$nodes = Model_gesa::getNodeLink($dbconnection,$gesa->getId(),Model_esia::NODE_INSTANCE);
		$devType = Model_esia::getDeviceType($dbconnection);
	$list_node=array();
	foreach($nodes as $node)
	{
		//page de control du noeud suivant sont type
		$page_control='/node_view.php?nodeid='.$node->getName();
		//page de contrôle
		if(!empty($devType[$node->getType()]['web_plugin_control_page']))
		{
			$page_control = Model_esia::replacePageControlVariable($devType[$node->getType()]['web_plugin_control_page'],$node);
			$page_control = $devType[$node->getType()]['web_plugin_apache_path'].$page_control;
		}
		//tableau contenant toutes les informations
		$descr = htmlentities($node->getDescription() , ENT_QUOTES);
		$list_node[]=array('name'=>$node->getName(),
				'ip_address'=>$node->getIPAddress(),
				'ip_dec_address'=>preg_replace('#\n#','',$node->getIPv4DecimalAdress()),
				'type'=>$node->getType(),
				'group'=>$node->getGroup(),
				'Description'=>nl2br($descr),
				'control_page'=>$page_control);
	}
	$smarty->assign('node_list',$list_node);
	$smarty->assign('action','showNode');
}
$smarty->assign('l_gesa_nodelink', $lang['GESA_NODELINK']);
$smarty->assign('l_gesa_nodelink_nbr', $lang['GESA_NODELINK_NBR']);
$smarty->assign('l_gesa_sn', $lang['GESA_SN']);
$smarty->assign('l_gesa_slot', $lang['GESA_SLOT_USED']);
$smarty->assign('l_gesa_model', $lang['GESA_MODEL']);
$smarty->assign('l_gesa_client', $lang['GESA_CLIENT']);
$smarty->assign('l_gesa_server', $lang['GESA_SERVER']);
$smarty->assign('l_gesa_kernel', $lang['GESA_KERNEL']);
$smarty->assign('l_gesa_os_version', $lang['GESA_OS_VERSION']);
$smarty->assign('l_gesa_activate_date', $lang['GESA_ACTIVATE_DATE']);
$smarty->assign('l_name_node', $lang['ADM_NAME']);
$smarty->assign('l_type_node', $lang['ADM_NODE_TYPE']);
$smarty->assign('l_description', $lang['ADM_DESCRIPTION']);
$smarty->assign('l_address_ip', $lang['ADM_ADDR_IP']);
$smarty->assign('l_group', $lang['ADM_GRP']);
$smarty->assign('l_show_graph', $lang['SHOW_GRAPH']);

$smarty->assign('l_show_historic', $lang['SHOW_HISTORIC']);
$smarty->assign('l_service_State', $lang['SERVICE_STATE']);
$smarty->assign('l_ctrl_lgd_title', $lang['SW_CTRL_SW_LGD_TITLE']);
$smarty->assign('l_ctrl_lgd_ok', $lang['LGD_OK']);
$smarty->assign('l_ctrl_lgd_unknown', $lang['LGD_UNKNOWN']);
$smarty->assign('l_ctrl_lgd_warn', $lang['LGD_WARN']);
$smarty->assign('l_ctrl_lgd_cri', $lang['LGD_CRI']);
$smarty->assign('l_information', $lang['INFORMATION_NODE']);
$smarty->assign('l_state_service', $lang['SERVICE_STATE']);
$smarty->assign('l_state_service_passifcheck', $lang['SERVICE_STATE_CHECK_PASSIF']);
$smarty->assign('l_modification', $lang['MODIF']);
$smarty->assign('l_gesa_load', $lang['GESA_LOAD']);


//vérification des droits d'accès au partie d'administration d'ESIA
if($user->getDroits($dbconnection,"esia_administration"))
{
	$smarty->assign('l_admin', $lang['ADMIN']);
}
//affichage de la page
$temps = microtime();
$temps = explode(' ', $temps);
$fin = $temps[1] + $temps[0];
// On affiche la différence entre des deux valeurs
$smarty->assign('execute_time',round(($fin - $debut),6) );
$smarty->assign('template_path',$template_path);
$smarty->display($template_path.'gesa_control.html');
?>
